#include <stdio.h>
#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <dos.h>
#include "kb.h"

#define a_0    0
#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

#define VIEW_ANGLE   60
#define SCREEN_RES   320
#define ANGLE_CONST  VIEW_ANGLE / SCREEN_RES

const float MUL_CONST = SCREEN_RES / VIEW_ANGLE;

void far *data1 = malloc(17000);
void far *data2 = malloc(17000);
unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[1920];
float cos_table[60];
int color_table[4096];
int index = 0;

int tex_off, main_off = 0, tex_flag;

void build_table(int k)
{
  int delta, delta1;

  for (int i = 0; i < 256; i++)
  {
    delta = 768;

    for (int j = 0; j < 256; j++)
    {
      delta1 = 0;

      for (int n = 0; n < 3; n++)
        delta1 += abs(pal[i * 4 + n] - pal[j * 4 + n] / (2 * (k + 1)));

      if (delta1 < delta)
      {
        delta = delta1;
        index = j;
      }
    }

    color_table[i + k * 256] = index;
  }
}

int dist(int a, unsigned int x_p, unsigned int y_p)
{
  float x = x_p, y = y_p, m, x_dist, y_dist, x_ = x_p, y_ = y_p;

  if (a < ANGLE_90 || a > ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128 + 128;
    y += (x_p - x) * tan_table[a];
    while ((!map[(int)x >> 7][(int)y >> 7]) && (y > 0) && (y < 4096) && (x < 4096))
    {
      x += 128;
      y -= m;
    }
  }
  else
  if (a > ANGLE_90 && a < ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128;
    y += (x_p - x) * tan_table[a];
    while (!map[(int)(x - 128) >> 7][(int)y >> 7] && y > 0 && x > 0 && y < 4096)
    {
      x -= 128;
      y += m;
    }
  }
  x_dist = sqrt(pow(x - x_p, 2) + pow(y - y_p, 2));

  if (a > ANGLE_180 && a < ANGLE_360)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128 + 128;
    x_ += (y_p - y_) / tan_table[a];
    while ((!map[(int)x_ >> 7][(int)y_ >> 7]) && (x_ > 0) && (x_ < 4096) && (y_ < 4096))
    {
      y_ += 128;
      x_ -= m;
    }
  }
  else
  if (a < ANGLE_180 && a > ANGLE_0)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128;
    x_ += (y_p - y_) / tan_table[a];
    while (!map[(int)x_ >> 7][(int)(y_ - 128) >> 7] && x_ > 0 && y_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ += m;
    }
  }
  y_dist = sqrt(pow(x_ - x_p, 2) + pow(y_ - y_p, 2));

//  setcolor(14);
  if (x_dist < y_dist && x_dist != 0)
  {
    tex_off = int(y) % 128;
    tex_flag = 0;
    return x_dist;
  }
  if (y_dist < x_dist && y_dist != 0)
  {
    tex_off = int(x_) % 128;
    tex_flag = 1;
    return y_dist;
  }
// line(x_p * 14 / 128.0, y_p * 14 / 128.0, x * 14 / 128.0, y * 14 / 128.0);
//  if (y_dist < x_dist)
//    line(x_p * 14 / 128.0, y_p * 14 / 128.0, x_ * 14 / 128.0, y_ * 14 / 128.0);
//  delay(10);

  return 0;
}

int dist2(int angle, unsigned int xp, unsigned int yp)
{
  long int x = xp, y = yp;
  float x_dist, y_dist;
  float m;
  long int x_ = xp, y_ = yp;

//**********************************************************

  if (angle < 90 * MUL_CONST || angle > 270 * MUL_CONST)
  {
    m = 128 * tan_table[angle];
    x = ((x >> 7) + 1) << 7;
    y += (x - xp) * tan_table[angle];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y += m;
    }
  }
  if (angle > 90 * MUL_CONST && angle < 270 * MUL_CONST)
  {
    m = 128 * tan_table[angle];
    x = ((x >> 7) + 1) << 7;
    y += (xp - x) * tan_table[angle];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y -= m;
    }
    x += 128;
  }
  x_dist = sqrt(pow(x - xp, 2) + pow(y - yp, 2));

  if (angle > 0 * MUL_CONST && angle < 180 * MUL_CONST)
  {
    m = 128 / tan_table[angle];
    y_ = ((y_ >> 7) + 1) << 7;
    x_ += (yp - y_) / tan_table[angle];
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ += m;
    }
  }
  if (angle > 180 * MUL_CONST && angle < 360 * MUL_CONST)
  {
    m = 128 / tan_table[angle];
    y_ = ((y_ >> 7) + 1) << 7;
    x += (y_ - yp) / tan_table[angle];
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ += 128;
      x_ -= m;
    }
    y_ += 128;
  }
  y_dist = sqrt(pow(x_ - xp, 2) + pow(y_ - yp, 2));
//    delay(5);

/*  if (angle >= 0 && angle < 90 * MUL_CONST)
  {
    x = ((x >> 7) + 1) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp - (x - xp) * tan_table[angle];
    }
  }
  else
  if (angle <= 180 * MUL_CONST)
  {
    x = (x >> 7) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp - (xp - x) * tan_table[(int)(179 * MUL_CONST) - angle];
    }
    x += 128;
  }
  else
  if (angle <= 270 * MUL_CONST)
  {
    x = (x >> 7) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp + (xp - x) * tan_table[angle - (int)(181 * MUL_CONST)];
    }
    x += 128;
  }
  else
  if (angle <= 360 * MUL_CONST)
  {
    x = ((x >> 7) + 1) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp + (x - xp) * tan_table[(int)(360 * MUL_CONST) - angle];
    }
  }                                             */
//  x_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));

  x_dist = sqrt(pow(x - xp, 2) + pow(y - yp, 2));

//**********************************************************

/*  if (angle > 0 && angle <= 90 * MUL_CONST)
  {
    y_ = (y_ >> 7) << 7;
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ = xp + (yp - y_) / tan_table[angle];
    }
    y_ += 128;
  }
  else
  if (angle <= 180 * MUL_CONST)
  {
    y_ = (y_ >> 7) << 7;
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ = xp + (y_ - yp) / tan_table[(int)(180 * MUL_CONST) - angle];
    }
    y_ += 128;
  }
  else
  if (angle <= 270 * MUL_CONST)
  {
    y_ = ((y_ >> 7) + 1) << 7;
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ += 128;
      x_ = xp - (y_ - yp) / tan_table[angle - (int)(180 * MUL_CONST)];
    }
  }
  else
  if (angle < 360 * MUL_CONST)
  {
    y_ = ((y_ >> 7) + 1) << 7;
    while (!map[x_ >> 7][y_ >> 7] && x_ > 0 && x_ < 4096)
    {
      y_ += 128;
      x_ = xp + (y_ - yp) / tan_table[(int)(360 * MUL_CONST) - angle];
    }
  }
  y_dist = sqrt(pow(x_ - xp, 2) + pow(y_ - yp, 2));*/

//  if (x_ > 4096) y_dist = 32768;
//  if (x_ < 0) y_dist = 32768;
//  if (y > 4096) x_dist = 32768;
//  if (y < 0) x_dist = 32768;
//  if (x_dist == 0) x_dist = 32768;
//  if (y_dist == 0) y_dist = 32768;

//**********************************************************

/*  if (angle < 90 || angle > 270)
  {
    x = ((x >> 7) + 1) << 7;
    y += (x - xp) * tan_table[offs];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp + (x - xp) * tan_table[offs];
    }
  }
  else
  if (angle != 90 && angle != 270)
  {
    x = (x >> 7) << 7;
    y += (x - xp) * tan_table[offs];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp + (x - xp) * tan_table[offs];
    }
    x += 128;
  }
  x_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));
  x_ = x;
  y_ = y;

  x = xp, y = yp;
  if (angle > 0 && angle < 180)
  {
    y = ((y >> 7) + 1) << 7;
    if (tan_table[offs] != 0)
      x += (y - yp) / tan_table[offs];
    while (!map[x >> 7][y >> 7] && x > 0 && x < 4096)
    {
      y += 128;
      if (tan_table[offs] != 0)
        x = xp + (y - yp) / tan_table[offs];
    }
  }
  else
  if (angle != 0 && angle != 180)
  {
    y = (y >> 7) << 7;
    if (tan_table[offs] != 0)
      x += (y - yp) / tan_table[offs];
    while (!map[x >> 7][y >> 7] && x > 0 && x < 4096)
    {
      y -= 128;
      if (tan_table[offs] != 0)
        x = xp + (y - yp) / tan_table[offs];
    }
    y += 128;
  }
  y_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));*/

//  if ((x_dist < y_dist)/* && (x_dist > 0)*/)
//  {
  setcolor(14);
  line(xp * 14 / 128.0, yp * 14 / 128.0, x_ * 14 / 128.0, y_ * 14 / 128.0);
  return x_dist;
//  }
//if ((y_dist < x_dist)/* && (y_dist > 0)*/)
//{
//    setcolor(15);
//    line(xp * 14 / 128.0, yp * 14 / 128.0, x_ * 14 / 128.0, y_ * 14 / 128.0);
//    return y_dist;
//}
//  else
//return 1;
}

void fill_tables()
{
  float angle = 0;
  for (int i = 0; i < 1920; i++)
  {
    if (angle != ANGLE_90 && angle != ANGLE_270)
      tan_table[i] = sin(angle * M_PI / 180) / cos(angle * M_PI / 180);
    angle += 0.1875;
  }

  for (int i = 0; i < 60; i++)
    cos_table[i] = cos((i - 30) * M_PI / 180);
}

int select_color(int distance)
{
  int color = 15;

  for (int i = 0; i < 15; i++)
    if (distance > i * 256) color--;

  return color + 96;
}

void vert_ret()
{
  asm
  {
      cli
      mov    dx,  03DAh
@1:   in     al,  dx
      test   al,  8
      jz     @1
@2:   in     al,  dx
      test   al,  8
      jnz    @2
      sti
  }
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void put_pixel(unsigned int x, unsigned int y, unsigned char color)
{
  asm
  {
      cmp    x,   319
      ja     @1
      cmp    y,   199
      ja     @1
      push   es
      mov    ax,  0A000h
      mov    es,  ax
      xor    dx,  dx
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      stosb
      pop    es
@1:
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void put_line(int x, int from, int to, unsigned char c1, unsigned char c2, int off, int col)
{
//  printf("%d\n",tex_off);
//  int o = off;
//  o += main_off;
//  if (o > 127) o -= 127;
  char z = tex_flag;
  asm
  {
      push   ds
      cmp    z,   0
      jz    @@4
      lds    si,  data1
      jmp @@5
@@4:  lds    si,  data2
@@5:  mov    ax,  0A000h
      mov    es,  ax
      mov    di,  x
      mov    cx,  200
@1:   mov    al,  c1
      cmp    cx,  from
      jb     @2
      cmp    cx,  to
      ja     @2

      xor    dx,  dx
      mov    ax,  32512
      mov    bx,  to
      sub    bx,  from
      div    bx
      mov    bx,  200
      sub    bx,  cx
      sub    bx,  from
      mul    bx
      shr    ax,  8
      shl    ax,  7
      add    ax,  off
      add    ax,  4
      mov    si,  ax
      mov    al,  ds:[si]

@2:   stosb
      add    di,  319
      loop   @1
      pop    ds
  }
}

void load()
{
  FILE *f;
  int i = 0, j = 0;
  char c;

  f = fopen("057-013.bmp", "rb");
  fseek(f, 54, 0);
  fread(pal, 1024, 1, f);
  fread((unsigned char *)data1, 16384, 1, f);
  fclose(f);
  f = fopen("059-013.bmp", "rb");
  fseek(f, 1078, 0);
  fread((unsigned char *)data2, 16384, 1, f);
  fclose(f);

  f = fopen("map.txt", "rt");

  do
  {
    c = getc(f);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  fclose(f);
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void main(int argc, char *argv[])
{
  char key;
  float xp = 2048, yp = 2048, tx, ty;
  float angle_p = 0, angle;
  int m;
  int color, base_color = 128, d, gm, gd = DETECT;

  if (argc == 2)
  {
    angle_p = atof(argv[1]);
  }

//  initgraph(&gd, &gm, "c:\\lng\\bc5\\bgi");
  load();
  set_mode(0x13);
  set_pal();
//  for (int i = 0; i < 16; i++)
//    build_table(i);
  fill_tables();

/*  setcolor(8);
  for (int i = 0; i < 33; i++)
  {
    line(i * 14, 0, i * 14, 448);
    line(0, i * 14, 448, i * 14);
  }

  setfillstyle(1, 7);
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j])
        bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);*/

  do
  {
//    if (kbhit())
//    {
    key = inportb(0x60);
//   key = getch();
    tx = xp;
    ty = yp;
    switch (key)
    {
      case 80: tx += sin((angle_p - 90) * M_PI / 180) * 32;
               ty += cos((angle_p - 90) * M_PI / 180) * 32; break;
      case 72: tx -= sin((angle_p - 90) * M_PI / 180) * 32;
               ty -= cos((angle_p - 90) * M_PI / 180) * 32; break;
      case 77: angle_p += 2; break;
      case 75: angle_p -= 2; break;
    }
    if (!map[int(tx) / 128][int(ty) / 128])
    {
      xp = tx;
      yp = ty;
    }
/*  cleardevice();

  setcolor(8);
  for (int i = 0; i < 33; i++)
  {
    line(i * 14, 0, i * 14, 448);
    line(0, i * 14, 448, i * 14);
  }

  setfillstyle(1, 7);
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j])
        bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);*/
//  }

    if (key >= 2 && key <= 10) base_color = (key - 38) * 16;
    if (angle_p > 359) angle_p = 0;
    if (angle_p < 0) angle_p = 359;
    vert_ret();
    for (int i = 0; i < 320; i++)
    {
      angle = (angle_p - 30) * 5.3333333333 + i;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
      d = dist(angle, xp, yp);
      if (d)
      {
        m = 32768 / (d * cos((i * 0.1875 - 30) * M_PI / 180));
        color = 16 - (d >> 7);
        if (color > 15) color = 15;
        if (color < 0) color = 0;
        if (m > 200) m = 200;
        put_line(i, 100 - m / 2, 100 + m / 2, 252, color, tex_off, color * 256);
      }
     }
      main_off++;
      if (main_off > 127) main_off = 0;
//      getch();
//      closegraph();
//     return;
    K_Reset();
  } while (key != 1);

//  closegraph();
  set_mode(0x3);
}
