/****************************************************************************/
/*               祭  祭 祩              */
/*                       ᯮ짮 楫 ᥫ.                       */
/*                       Copyright (c) MATI Inc. 1999                       */
/****************************************************************************/

#include <iostream.h>
#include <conio.h>
#include <math.h>
#include <time.h>

#define CELL_SIZE     128
#define M             65536L
#define N_DIGIT       23
#define M_DIGIT       16
#define INF           2147483647L
#define MAP_SIZE      12
#define ANGLE_INC     0.1875
#define TABLE_SIZE    1920
#define DEMO_SIZE     16
#define STEP_SIZE     8
#define ANGLE_STEP    10

#define ANGLE_0       0
#define ANGLE_90      480
#define ANGLE_180     960
#define ANGLE_270     1440
#define ANGLE_360     TABLE_SIZE

long tan_table[TABLE_SIZE];
long ctn_table[TABLE_SIZE];
long sin_table[TABLE_SIZE];
long cos_table[TABLE_SIZE];

unsigned color_flag;
long dist = INF;

char map[MAP_SIZE][MAP_SIZE] =
{{1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,0,0,1},
 {1,0,1,1,1,0,0,0,0,0,0,1},
 {1,0,1,1,1,1,0,0,1,1,1,1},
 {1,0,1,1,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,1,0,0,1},
 {1,1,1,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,1,1,1,1,1,1,1,1,1,1,1}};

char x_data[DEMO_SIZE] = {1,4,4,9,9,10,10,7,7,10,10,1,1,4,4,1};
char y_data[DEMO_SIZE] = {10,10,7,7,4,4,10,10,2,2,1,1,6,6,8,8};
char a_data[DEMO_SIZE] = {0,1,0,1,0,3,2,1,0,1,2,3,0,3,2,3};

long Distance(long player_x, long player_y, int angle)
{
  long x = player_x << M_DIGIT, y = player_y << M_DIGIT;
  long xp = x, yp = y, N = CELL_SIZE * M;
  long x_dist, y_dist, INC, A;
  long MAP_SIZE_N = MAP_SIZE * N;
  unsigned cf1, cf2;

  if (angle < 0) angle = TABLE_SIZE - 1 - (-angle) % TABLE_SIZE;
  if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

  if ((angle != ANGLE_0) && (angle != ANGLE_180))
  {
    if ((angle > ANGLE_0) && (angle < ANGLE_180))
    {
      yp = y % N;
      xp += (yp >> M_DIGIT) * ctn_table[angle];
      yp = y - yp;
      INC = -N;
      A = -1;
      cf1 = 0;
    }
    else
    {
      yp = N - (y % N);
      xp -= (yp >> M_DIGIT) * ctn_table[angle];
      yp += y;
      INC = N;
      A = 0;
      cf1 = 1;
    }
    while(!map[(yp >> N_DIGIT) + A][xp >> N_DIGIT] && (xp > 0) && (xp < MAP_SIZE_N))
    {
      yp += INC;
      xp -= (INC >> M_DIGIT) * ctn_table[angle];
    }

    if (!cos_table[angle])
      x_dist = (yp - y) >> M_DIGIT;
    else
      x_dist = (xp - x) / cos_table[angle];
    if (x_dist < 0) x_dist = -x_dist;
  }
  else x_dist = INF;

  xp = x, yp = y;
  if ((angle != ANGLE_90) && (angle != ANGLE_270))
  {
    if ((angle > ANGLE_90) && (angle < ANGLE_270))
    {
      xp = x % N;
      yp += (xp >> M_DIGIT) * tan_table[angle];
      xp = x - xp;
      INC = -N;
      A = -1;
      cf2 = 0;
    }
    else
    {
      xp = N - (x % N);
      yp -= (xp >> M_DIGIT) * tan_table[angle];
      xp += x;
      INC = N;
      A = 0;
      cf2 = 1;
    }
    while(!map[yp >> N_DIGIT][(xp >> N_DIGIT) + A] && (yp > 0) && (yp < MAP_SIZE_N))
    {
      xp += INC;
      yp -= (INC >> M_DIGIT) * tan_table[angle];
    }

    if (!sin_table[angle])
      y_dist = (xp - x) >> M_DIGIT;
    else
      y_dist = (yp - y) / sin_table[angle];
    if (y_dist < 0) y_dist = -y_dist;
  }
  else y_dist = INF;

  if (y_dist < x_dist)
  {
    color_flag = cf2 + 2;
    return y_dist;
  }
  else if (x_dist < y_dist)
  {
    color_flag = cf1;
    return x_dist;
  }

  return dist;
}

void BuildTables()
{
  for (int i = 0; i < TABLE_SIZE; i++)
  {
    sin_table[i] = (long)(M * sin(i * ANGLE_INC * M_PI / 180));
    cos_table[i] = (long)(M * cos(i * ANGLE_INC * M_PI / 180));
    if (cos_table[i])
      tan_table[i] = (long)(M * tan(i * ANGLE_INC * M_PI / 180));
    else
      tan_table[i] = INF;
    if (sin_table[i])
      ctn_table[i] = (long)(M / tan(i * ANGLE_INC * M_PI / 180));
    else
      ctn_table[i] = INF;
  }
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void put_line(int x, int from, int to, unsigned char c)
{
  asm
  {
      push   0A000h
      pop    es
      mov    di,  x
      mov    cx,  200
@@1:  mov    al,  cl
      sub    al,  136
      jnc    @@3
      mov    al,  0
@@3:  cmp    cx,  from
      jb     @@2
      cmp    cx,  to
      ja     @@2
      mov    al,  c
@@2:  stosb
      add    di,  319
      loop   @@1
  }
}

void vert_ret()
{
  asm
  {
      cli
      mov    dx,  03DAh
@@1:  in     al,  dx
      test   al,  8
      jz     @@1
@@2:  in     al,  dx
      test   al,  8
      jnz    @@2
      sti
  }
}

void set_rgb(char n, char r, char g, char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      out    dx,  al
      mov    al,  g
      out    dx,  al
      mov    al,  b
      out    dx,  al
  }
}

int sign_func(int arg)
{
  if (arg < 0) return -1;
  if (arg > 0) return 1;

  return 0;
}

void main()
{
  long player_x = 192, player_y = 1344;
  long angle = ANGLE_0, m;
  int  rotate = -1, i, k, demo_pointer = 0;
  unsigned color;
  unsigned long frames = 0, t;

  BuildTables();
  set_mode(0x13);

  for (i = 0; i < 64; i++)
  {
    set_rgb(i, 0, 0, i);
    set_rgb(i + 64, 0, i, 0);
    set_rgb(i + 128, i, 0, 0);
    set_rgb(i + 192, i, i, i);
  }

  t = clock();

  do
  {
    for (i = 0; i < 320; i++)
    {
      dist = Distance(player_x, player_y, angle + 160 - i);
      if (dist)
      {
        k = TABLE_SIZE - 160 + i;
        m = 16384 / ((dist * cos_table[k % TABLE_SIZE]) >> M_DIGIT);
        color = 63 - (dist >> 4);
        if (color > 63) color = 0;
        color += color_flag << 6;
        if (m > 99)
          put_line(i, 0, 199, color);
        else
          put_line(i, 100 - m, 100 + m, color);
      }
    }
    frames++;

    if (rotate < 0)
    {
      player_x += STEP_SIZE * sign_func(x_data[(demo_pointer + 1) % DEMO_SIZE] -
                                        x_data[demo_pointer]);
      player_y += STEP_SIZE * sign_func(y_data[(demo_pointer + 1) % DEMO_SIZE] -
                                        y_data[demo_pointer]);

      for (i = 0; i < DEMO_SIZE; i++)
      {
        if ((player_x == x_data[(demo_pointer + 1) % DEMO_SIZE] * CELL_SIZE + 64) &&
            (player_y == y_data[(demo_pointer + 1) % DEMO_SIZE] * CELL_SIZE + 64))
        {
          demo_pointer++;
          demo_pointer %= DEMO_SIZE;
          rotate = a_data[demo_pointer] * ANGLE_90;
          break;
        }
      }
    }
    else
    {
      angle += ANGLE_STEP * sign_func(a_data[(demo_pointer + 1) % DEMO_SIZE] -
                                      a_data[demo_pointer]);
    }

    if (angle < 0) angle = TABLE_SIZE - (-angle) % TABLE_SIZE;
    if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

    if ((angle == rotate) && (rotate >= 0)) rotate = -1;

  } while (!kbhit());

  set_mode(0x03);
  cout << "Copyright (c) MATI Inc. 1999\n";

  t = clock() - t;
  cout << (double)frames * CLK_TCK / t << " FPS\n";
  cout << frames << " frames, " << (double)t / CLK_TCK << " seconds\n";
}

