/****************************************************************************/
/*               祭  祭 祩              */
/*                       ᯮ짮 楫 ᥫ.                       */
/*                       Copyright (c) MATI Inc. 1999                       */
/****************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include <dos.h>

#define CELL_SIZE     128
#define M             65536L
#define N_DIGIT       23
#define M_DIGIT       16
#define INF           2147483647L
#define MAP_SIZE      20
#define DEMO_SIZE     16
#define STEP_SIZE     8
#define ANGLE_STEP    10

#define ANGLE_INC     0.214285714
#define TABLE_SIZE    1680
#define ANGLE_0       0
#define ANGLE_90      420
#define ANGLE_180     840
#define ANGLE_270     1260
#define ANGLE_360     TABLE_SIZE

long tan_table[TABLE_SIZE];
long ctn_table[TABLE_SIZE];
long sin_table[TABLE_SIZE];
long cos_table[TABLE_SIZE];
int delta[560];

unsigned color_flag;
long dist = INF;

char map[MAP_SIZE][MAP_SIZE] =
{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,1},
 {1,1,1,0,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
 {1,1,1,1,1,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1},
 {1,0,0,0,1,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,1,0,0,1,0,0,0,1,1,1,1,1,1,0,0,1},
 {1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,1,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1},
 {1,0,0,0,1,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1},
 {1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1},
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};

char x_data[DEMO_SIZE] = {1,4,4,9,9,10,10,7,7,10,10,1,1,4,4,1};
char y_data[DEMO_SIZE] = {10,10,7,7,4,4,10,10,2,2,1,1,6,6,8,8};
char a_data[DEMO_SIZE] = {0,1,0,1,0,3,2,1,0,1,2,3,0,3,2,3};

long player_x = 192, player_y = 1344;
long angle = ANGLE_0;
void interrupt (*old_vect)(...);
unsigned exit_flag = 0, l = 0, r = 0, f = 0, b = 0;
int page = 0;


long Distance(long player_x, long player_y, int angle)
{
  long x = player_x << M_DIGIT, y = player_y << M_DIGIT;
  long xp = x, yp = y, N = CELL_SIZE * M;
  long x_dist, y_dist, INC, A;
  long MAP_SIZE_N = MAP_SIZE * N;
  unsigned cf1, cf2;

  if (angle < 0) angle = TABLE_SIZE - 1 - (-angle) % TABLE_SIZE;
  if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

  if ((angle != ANGLE_0) && (angle != ANGLE_180))
  {
    if ((angle > ANGLE_0) && (angle < ANGLE_180))
    {
      yp = y % N;
      xp += (yp >> M_DIGIT) * ctn_table[angle];
      yp = y - yp;
      INC = -N;
      A = -1;
      cf1 = 0;
    }
    else
    {
      yp = N - (y % N);
      xp -= (yp >> M_DIGIT) * ctn_table[angle];
      yp += y;
      INC = N;
      A = 0;
      cf1 = 1;
    }
    while(!map[(yp >> N_DIGIT) + A][xp >> N_DIGIT] && (xp > 0) && (xp < MAP_SIZE_N))
    {
      yp += INC;
      xp -= (INC >> M_DIGIT) * ctn_table[angle];
    }

    if (!cos_table[angle])
      x_dist = (yp - y) >> M_DIGIT;
    else
      x_dist = (xp - x) / cos_table[angle];
    if (x_dist < 0) x_dist = -x_dist;
  }
  else x_dist = INF;

  xp = x, yp = y;
  if ((angle != ANGLE_90) && (angle != ANGLE_270))
  {
    if ((angle > ANGLE_90) && (angle < ANGLE_270))
    {
      xp = x % N;
      yp += (xp >> M_DIGIT) * tan_table[angle];
      xp = x - xp;
      INC = -N;
      A = -1;
      cf2 = 0;
    }
    else
    {
      xp = N - (x % N);
      yp -= (xp >> M_DIGIT) * tan_table[angle];
      xp += x;
      INC = N;
      A = 0;
      cf2 = 1;
    }
    while(!map[yp >> N_DIGIT][(xp >> N_DIGIT) + A] && (yp > 0) && (yp < MAP_SIZE_N))
    {
      xp += INC;
      yp -= (INC >> M_DIGIT) * tan_table[angle];
    }

    if (!sin_table[angle])
      y_dist = (xp - x) >> M_DIGIT;
    else
      y_dist = (yp - y) / sin_table[angle];
    if (y_dist < 0) y_dist = -y_dist;
  }
  else y_dist = INF;

  if (y_dist < x_dist)
  {
    color_flag = cf2 + 2;
    return y_dist;
  }
  else if (x_dist < y_dist)
  {
    color_flag = cf1;
    return x_dist;
  }

  return dist;
}

void BuildTables()
{
  int i;

  for (i = 0; i < TABLE_SIZE; i++)
  {
    sin_table[i] = (long)(M * sin(i * ANGLE_INC * M_PI / 180));
    cos_table[i] = (long)(M * cos(i * ANGLE_INC * M_PI / 180));
    if (cos_table[i])
      tan_table[i] = (long)(M * tan(i * ANGLE_INC * M_PI / 180));
    else
      tan_table[i] = INF;
    if (sin_table[i])
      ctn_table[i] = (long)(M / tan(i * ANGLE_INC * M_PI / 180));
    else
      ctn_table[i] = INF;
  }

  for (i = 0; i < 560; i++)
    delta[i] = 0;
}

void PrintTables()
{
  ofstream out("tables.inc");
  int i, j;

  for (i = 0; i < TABLE_SIZE / 10; i++)
  {
    out << "        DD    ";
    for (j = 0; j < 10; j++)
    {
      out << hex;
      out.setf(0x200);
      out.fill('0');
      out.width(9);
      if (j != 9)
        out << (unsigned long)sin_table[i * 10 + j] << "H,";
      else
        out << (unsigned long)sin_table[i * 10 + j] << "H\n";
    }
  }
  out << '\n';

  for (i = 0; i < TABLE_SIZE / 10; i++)
  {
    out << "        DD    ";
    for (j = 0; j < 10; j++)
    {
      out << hex;
      out.setf(0x200);
      out.fill('0');
      out.width(9);
      if (j != 9)
        out << (unsigned long)cos_table[i * 10 + j] << "H,";
      else
        out << (unsigned long)cos_table[i * 10 + j] << "H\n";
    }
  }
  out << '\n';

  for (i = 0; i < TABLE_SIZE / 10; i++)
  {
    out << "        DD    ";
    for (j = 0; j < 10; j++)
    {
      out << hex;
      out.setf(0x200);
      out.fill('0');
      out.width(9);
      if (j != 9)
        out << (unsigned long)tan_table[i * 10 + j] << "H,";
      else
        out << (unsigned long)tan_table[i * 10 + j] << "H\n";
    }
  }
  out << '\n';

  for (i = 0; i < TABLE_SIZE / 10; i++)
  {
    out << "        DD    ";
    for (j = 0; j < 10; j++)
    {
      out << hex;
      out.setf(0x200);
      out.fill('0');
      out.width(9);
      if (j != 9)
        out << (unsigned long)ctn_table[i * 10 + j] << "H,";
      else
        out << (unsigned long)ctn_table[i * 10 + j] << "H\n";
    }
  }
  out << '\n';

  for (i = 0; i < MAP_SIZE; i++)
  {
    out << "        DB    ";
    for (j = 0; j < MAP_SIZE; j++)
    {
      if (j != MAP_SIZE - 1)
        out << (int)map[i][j] << ',';
      else
        out << (int)map[i][j] << '\n';
    }
  }
  out << '\n';

  out.close();
}

void set_text_mode()
{
  asm
  {
      mov    ax,  3
      int    10h
  }
}

void set_graph_mode()
{
  asm
  {
      mov    ax,  13h
      int    10h
      mov    dx,  3C4h
      mov    al,  4
      out    dx,  al
      inc    dx
      in     al,  dx
      or     al,  4
      and    al,  0F7h
      out    dx,  al
      mov    dx,  3D4h
      mov    al,  14h
      out    dx,  al
      inc    dx
      in     al,  dx
      and    al,  0BFh
      out    dx,  al
      dec    dx
      mov    al,  17h
      out    dx,  al
      inc    dx
      in     al,  dx
      or     al,  40h
      out    dx,  al
      push   0A000h
      pop    es
      xor    di,  di
      xor    ax,  ax
      mov    cx,  8000h
      cld
      rep    stosw
  }
}

void put_line(int x, int delta, int from, int to, unsigned char c, unsigned page)
{
  asm
  {
      push   0A000h
      pop    es
      mov    cx,  x
      mov    dx,  3C4h
      mov    al,  2
      and    cl,  3
      mov    ah,  1
      shl    ah,  cl
      out    dx,  ax
      mov    di,  x
      shr    di,  2
      add    di,  page
      add    di,  1600
      mov    dx,  delta
      mov    ax,  from
      sub    ax,  delta
      jns    @@7
      mov    dx,  from
@@7:  mov    ax,  dx
      mov    bx,  ax
      shl    ax,  6
      shl    bx,  4
      add    di,  ax
      add    di,  bx
      cmp    from,  0
      jz     @@2
      mov    cx,  from
      sub    cx,  dx
      cmp    cl,  0
      jz     @@2
      mov    ax,  191
      sub    ax,  dx
      cmp    al,  128
      jae    @@1
      mov    al,  0
@@1:  stosb
      cmp    al,  128
      jbe    @@6
      dec    al
@@6:  add    di,  79
      loop   @@1
@@2:  mov    al,  c
      mov    cx,  to
      sub    cx,  from
@@3:  stosb
      add    di,  79
      loop   @@3
      cmp    from,  0
      jz     @@5
      xor    al,  al
      mov    cx,  from
      sub    cx,  dx
      cmp    cl,  0
      jz     @@5
@@4:  stosb
      add    di,  79
      loop   @@4
@@5:
  }
}

//void put_line(int x, int from, int to, unsigned char c, unsigned page)
//{
//  asm
//  {
//      push   0A000h
//      pop    es
//      mov    cx,  x
//      mov    dx,  3C4h
//      mov    al,  2
//      and    cl,  3
//      mov    ah,  1
//      shl    ah,  cl
//      out    dx,  ax
//      mov    di,  x
//      shr    di,  2
//      add    di,  page
//      add    di,  1600
//      cmp    from,  0
//      jz     @@2
//      mov    cx,  from
//      mov    al,  191
//@@1:  stosb
//      cmp    al,  128
//      je     @@6
//      dec    al
//@@6:  add    di,  79
//      loop   @@1
//@@2:  mov    al,  c
//      mov    cx,  to
//      sub    cx,  from
//@@3:  stosb
//      add    di,  79
//      loop   @@3
//      cmp    from,  0
//      jz     @@5
//      xor    al,  al
//      mov    cx,  from
//@@4:  stosb
//      add    di,  79
//      loop   @@4
//@@5:
//  }
//}

void vert_ret()
{
  asm
  {
      cli
      mov    dx,  03DAh
@@1:  in     al,  dx
      test   al,  8
      jz     @@1
@@2:  in     al,  dx
      test   al,  8
      jnz    @@2
      sti
  }
}

void set_rgb(char n, char r, char g, char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      out    dx,  al
      mov    al,  g
      out    dx,  al
      mov    al,  b
      out    dx,  al
  }
}

void set_page(int page)
{
  char addr = 0;

  if (page) addr = 0x40;

  asm
  {
      mov    dx,  3D4h
      mov    al,  0Ch
      mov    ah,  addr
      out    dx,  ax
      mov    al,  0Dh
      xor    ah,  ah
      out    dx,  ax
  }
}

int sign_func(int arg)
{
  if (arg < 0) return -1;
  if (arg > 0) return 1;

  return 0;
}

void interrupt KB_HANDLER(...)
{
  unsigned char key = inportb(0x60);

  switch (key)
  {
    case  1:  exit_flag = 1; break;
    case 80:  b = 1; f = 0; break;
    case 72:  f = 1; b = 0; break;
    case 77:  r = 1; l = 0; break;
    case 75:  l = 1; r = 0; break;
    case 208: b = 0; f = 0; break;
    case 200: f = 0; b = 0; break;
    case 205: r = 0; l = 0; break;
    case 203: l = 0; r = 0; break;
  }

  asm
  {
      cli
      mov    dx,  20h
      mov    al,  20h
      out    dx,  al
  }
}

void main()
{
  int  rotate = -1, demo_pointer = 0, i;
  long m, a;
  int  k;
  unsigned color;
  unsigned long frames = 0, t;

  BuildTables();
  PrintTables();
  set_graph_mode();

  old_vect = _dos_getvect(0x09);
  _dos_setvect(0x09, KB_HANDLER);

  for (i = 0; i < 64; i++)
  {
    set_rgb(i, 0, 0, i);
    set_rgb(i + 64, 0, i, 0);
    set_rgb(i + 128, i, 0, 0);
    set_rgb(i + 192, i, i, i);
  }

  t = clock();

  do
  {

  if (l) angle += 5;
  if (r) angle -= 5;

  if (angle < 0) angle = TABLE_SIZE - (-angle) % TABLE_SIZE;
  if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

  if (f)
  {
    player_x += long((STEP_SIZE * cos_table[angle]) >> M_DIGIT);
    player_y -= long((STEP_SIZE * sin_table[angle]) >> M_DIGIT);
  }
  if (b)
  {
    player_x -= long((STEP_SIZE * cos_table[angle]) >> M_DIGIT);
    player_y += long((STEP_SIZE * sin_table[angle]) >> M_DIGIT);
  }



    set_page(page ^ 1);
    vert_ret();

    for (i = 0; i < 280; i++)
    {
      dist = Distance(player_x, player_y, angle + 140 - i);
      if (dist)
      {
        k = TABLE_SIZE - 140 + i;
        asm mov ax, 1234
        m = 0x3800 / ((dist * cos_table[k % TABLE_SIZE]) >> M_DIGIT);
        color = 63 - (dist >> 5);
        if (color > 63) color = 0;
        color += color_flag << 6;
        if (m > 79)
        {
          put_line(i + 20, delta[i + page * 280], 0, 159, color, page * 0x4000);
          delta[i + page * 280] = 0;
        }
        else
        {
          put_line(i + 20, delta[i + page * 280], 80 - m, 80 + m, color, page * 0x4000);
          delta[i + page * 280] = 80 - m;
        }
      }
    }
    page ^= 1;
    frames++;

/*    if (rotate < 0)
    {
      player_x += STEP_SIZE * sign_func(x_data[(demo_pointer + 1) % DEMO_SIZE] -
                                        x_data[demo_pointer]);
      player_y += STEP_SIZE * sign_func(y_data[(demo_pointer + 1) % DEMO_SIZE] -
                                        y_data[demo_pointer]);

      for (i = 0; i < DEMO_SIZE; i++)
      {
        if ((player_x == x_data[(demo_pointer + 1) % DEMO_SIZE] * CELL_SIZE + 64) &&
            (player_y == y_data[(demo_pointer + 1) % DEMO_SIZE] * CELL_SIZE + 64))
        {
          demo_pointer++;
          demo_pointer %= DEMO_SIZE;
          rotate = a_data[demo_pointer] * ANGLE_90;
          break;
        }
      }
    }
    else
    {
      unsigned a1;
      if (!demo_pointer)
        a1 = a_data[DEMO_SIZE - 1];
      else
        a1 = a_data[demo_pointer - 1];
      unsigned a2 = a_data[demo_pointer];

      if ((!a1 && (a2 == 3)) || ((a1 == 3) && !a2))
        angle -= ANGLE_STEP * sign_func(a2 - a1);
      else
        angle += ANGLE_STEP * sign_func(a2 - a1);
    }*/


    if ((angle == rotate) && (rotate >= 0)) rotate = -1;

  } while (!exit_flag);

  _dos_setvect(0x09, old_vect);

  set_text_mode();
  cout << "Copyright (c) MATI Inc. 1999\n";

  t = clock() - t;
  cout << (double)frames * CLK_TCK / t << " FPS\n";
  cout << frames << " frames, " << (double)t / CLK_TCK << " seconds\n";
}
